/* $Id: unified-types.h,v 1.1 2003/06/03 21:30:11 krzyzak Exp $ */
#ifndef GGadu_UNIFIED_TYPES_H
#define GGadu_UNIFIED_TYPES_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


/*
 *    GGaduContact
 *    struktura opisujaca kontakt z dowolnego protokou
 *    jeli jakie pole == NULL GUI powinno je zignorowa
 */
 
typedef struct {
    gchar *id;		// unikalny identyfikator: numer GG, adres z tlen'u etc.
    gchar *first_name;	// imi
    gchar *last_name;	// nazwisko
    gchar *nick;	// pseudo
    gchar *mobile;	// tel. komrkowy
    gchar *email;	// adres e-mail
    gchar *gender;	// pe
    gchar *group;	// grupa
    gchar *comment;	// komentarz
    gchar *birthdate;	// data urodzenia
    gchar *status_descr;// opis do statusu
    gchar *ip; 	// "IP:PORT"
    gchar *city;	// miasto
    gchar *age;	//wiek
    gint status;	// status w postaci liczbowej
} GGaduContact;

void GGaduContact_free(GGaduContact *k);

/*
 *	Klasy wiadomoci
 */
 
enum {
    GGADU_CLASS_CHAT,
    GGADU_CLASS_MSG,
    GGADU_CLASS_CONFERENCE
};

enum {
    GGADU_SEARCH_FIRSTNAME,
    GGADU_SEARCH_LASTNAME,
    GGADU_SEARCH_NICKNAME,
    GGADU_SEARCH_CITY,
    GGADU_SEARCH_BIRTHYEAR,
    GGADU_SEARCH_GENDER,
    GGADU_SEARCH_ACTIVE,
    GGADU_SEARCH_ID
};


/*
 *	GGaduMsg
 *	opisuje przesylana wiadomosc
 */

typedef struct {
    gchar *id;
    gchar *message;
    guint class;
    guint time;
   
    /* conference */
    GSList *recipients;
    
} GGaduMsg;

void GGaduMsg_free(GGaduMsg *m);

/*
 *	GGaduNotify
 *	opisuje pojawienie sie kogos, lub zmiane stanu
 */

typedef struct {
    gchar *id;
    unsigned long status;
		gchar *ip; /* adres ip, nie musi byc ustawiony */
} GGaduNotify;

void GGaduNotify_free(GGaduNotify *n);

/*
 *	GGaduStatusPrototype
 *	prototyp statusu uzytownika danego protokou
 *
 */ 
 
typedef struct {
    gint status;		// identyfikator statusu
    gchar *description;		// wywietlany opis np. "Dostpny"
    gchar *image;		// nazwa pliku obrazeku statusu 
    gboolean receive_only;
} GGaduStatusPrototype;

void GGaduStatusPrototype_free(GGaduStatusPrototype *s);

typedef struct {
    gint	key;
    gpointer	value;

    guint	type; // VAR_STR, VAR_INT, VAR_BOOL
    guint	flag; // GGADU_INSENSITIVE, GGADU_SENSITIVE (default)
    
    gchar	*description;
    
    gpointer 	user_data;
} GGaduKeyValue;

typedef struct {
    gchar *title;
    gchar *callback_signal;
    gint response;
    GSList *optlist; // lista elementw GGaduKeyValue
    gpointer user_data;
    gint type;
} GGaduDialog;

void GGaduDialog_free(GGaduDialog *d);

#endif
